/*
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://jersey.dev.java.net/CDDL+GPL.html
 * or jersey/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at jersey/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 *
 * Contributor(s):
 *
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package com.sun.jersey.qe.util;

import com.sun.grizzly.http.SelectorThread;
import com.sun.jersey.api.container.grizzly.GrizzlyWebContainerFactory;
import java.net.URI;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Naresh (Srinivas.Bhimisetty@Sun.Com)
 */
public class GrizzlyContainer implements RunnableContainer {

    /**
     * Map of init params to be passed to the servlet.
     */
    private Map<String, String> initParams;

    /**
     * Handle to the Grizzly container.
     */
    private SelectorThread threadSelector;

    /**
     * Base uri for the resources.
     */
    private URI BASE_URI;

    /**
     * Default constructor.
     */
    public GrizzlyContainer() {
        
    }

    /**
     * Start grizzly and deploy endpoint.
     * @throws java.lang.Exception
     */
    public void start() throws Exception {
        // Create an instance of grizzly web container
            initParams = new HashMap<String, String>();
            initParams.put("com.sun.jersey.config.property.packages",
                "com.sun.jersey.qe.tests.helloworld.resources");
            System.out.println("Starting grizzly...");
            threadSelector = GrizzlyWebContainerFactory.create(BASE_URI,
                    com.sun.jersey.spi.container.servlet.ServletContainer.class, initParams);
    }

    /**
     * Stop grizzly server.
     * @throws java.lang.Exception
     */
    public void stop() throws Exception {
        // stop the grizzly thread selector instance
            threadSelector.stopEndpoint();
    }

    /**
     * Set base uri.
     * @param baseUri
     */
    public void setBaseUri(URI baseUri) {
        BASE_URI = baseUri;
    }

}